/* Zodiac - Font.h
 */

#ifndef Zodiac_Font
#define Zodiac_Font

#include <SDL_opengl.h>
#include <SDL_ttf.h>

class Font
{
private:
	TTF_Font *m_ttfFont;

	GLuint m_texture;
	GLfloat m_texCoords[4];

	Font(TTF_Font *font);
public:
	~Font();

	static Font* loadFromFile(const char *fileName, int pointSize);

	void drawText(int x, int y, const char *text);
	void drawTextFormatted(int x, int y, const char *format, ...);

	void getTextSize(const char *text, int &width, int &height);
};

#endif // include guard
