/* Zodiac - LevelGeometry.h
 */

#ifndef Zodiac_LevelGeometry
#define Zodiac_LevelGeometry

#include "MpdMesh.h"
#include "Texture.h"

class LevelGeometry
{
public:
	LevelGeometry();
	~LevelGeometry();

	// Load the fan tile descriptions
	bool loadFanTypes(const char *fileName);

	// Load the level's mesh and textures
	bool loadLevel(const char *levelDir);

	// Free bits o' data
	void resetFanTypes();
	void freeMesh();
	void freeTextures();

	// Other things are going to need to get at the level's internal data,
	// if only in a read-only fashion
	const MpdFanType *getFanTypes() const { return m_fanTypes; }
	const MpdMesh    *getMesh()     const { return m_mpdMesh; }
	const Texture    *getTexture(int index) const;

private:
	MpdFanType m_fanTypes[MPD_MaxFanTypes];
	MpdMesh *m_mpdMesh;
	Texture *m_mpdTextures[MPD_NumTextures];
};

#endif // include guard
