/* Zodiac - Texture.h
 * Texture loading!  Whoo!
 */

#ifndef Zodiac_Texture
#define Zodiac_Texture

struct SDL_Surface;

class Texture
{
 private:
    // Member data
    unsigned int m_binding;
    int m_width, m_height;
	int m_srcWidth, m_srcHeight;
    SDL_Surface *m_surface;

    // The constructor & destructor are private so that these things may only
    // be created/deleted via the factory functions and reference counting
    Texture();
    static Texture *load(const char *fileName);
    void upload();

 public:
	virtual ~Texture();
    static Texture *loadFromFile(const char *fileName);

    unsigned int binding() const { return m_binding; }
    int width() const { return m_width; }
    int height() const { return m_height; }

	int sourceWidth() const { return m_srcWidth; }
	int sourceHeight() const { return m_srcHeight; }
};

#endif // include guard
